Skip to main content
1.1 Install Razorpay Android Custom SDK. 1.2 Instantiate and Initialise Razorpay Android Custom SDK. 1.3 Create an Order in Server. 1.4 Fetch Payment Methods. 1.5 Set Up WebView. 1.6 Submit Payment Data and Handle Success and Error Events. 1.7 Store Fields in Your Server. 1.8 Verify Payment Signature. 1.9 Verify Payment Status.

1.1 Install Razorpay Android Custom SDK

Follow the steps given below to install the SDK in your Android project:
  • Add the code given below to your project’s top-level build.gradle file: This gives access to the SDK library.
    Java
    This adds the dependencies for the SDK.
  • If you are using SDK version 3.9.5 or below, download the file and add it to the libs directory.
Handy TipsFrom version 3.9.22 onwards, the latest version is automatically updated, eliminating the need for manual updates.

1.2 Instantiate and Initialise Razorpay Android Custom SDK

Instantiate

To instantiate Razorpay, pass a reference of your activity to the Razorpay constructor, as shown below:

Proguard Rules

If you are using Proguard for your builds, you need to add the following lines to your proguard-rules.pro file.
Java

Initialise

Add your API keys to AndroidManifest.xml.
Watch Out!API keys should not be hardcoded in the app. It should be sent from your server-side as an app-related metadata fetch.

Sample Code

For additional support on Payment Methods, such as fetching bank or wallet logos, fetching card network and information on how to validate card information,
XML
Handy TipsThe auto-OTP reading feature is available only for saved cards. Know more about saved cards.To set your API key programmatically, that is, at the runtime instead of statically defining it in your AndroidManifest.xml, you can pass it as a parameter to the Razorpay constructor, as shown below:

1.3 Create an Order in Server

Order is an important step in the payment process.
  • An order should be created for every payment.
  • You can create an order using the Orders API. It is a server-side API call. Know how to authenticate Orders API.
  • The order_id received in the response should be passed to the checkout. This ties the order with the payment and secures the request from being tampered.
Watch Out!Payments made without an order_id cannot be captured and will be automatically refunded. You must create an order before initiating payments to ensure proper payment processing.You can create an order using:Use this endpoint to create an order using the Orders API./orders
Curl
Success Response
You can use the Postman workspace below to create an order:
Handy TipsUnder the Authorization section in Postman, select Basic Auth and add the Key Id and secret as the Username and Password, respectively.You can create an order manually by integrating the API sample codes on your server.

Request Parameters

amount mandatory : integer The transaction amount, expressed in the currency subunit. For example, for an actual amount of , the value of this field should be 22225. currency mandatory : string The currency in which the transaction should be made. See the list of supported currencies. Length must be of 3 characters. receipt optional : string Your receipt id for this order should be passed here. Maximum length is 40 characters. notes optional : json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”. partial_payment optional : boolean Indicates whether the customer can make a partial payment. Possible values:
  • true: The customer can make partial payments.
  • false (default): The customer cannot make partial payments.
first_payment_min_amount optional : integer Minimum amount that must be paid by the customer as the first partial payment. For example, if an amount of ₹7,000 is to be received from the customer in two installments of #1 - ₹5,000, #2 - ₹2,000, then you can set this value as 500000. This parameter should be passed only if partial_payment is true.

Response Parameters

Descriptions for the response parameters are present in the Orders Entity parameters table.

Error Response Parameters

The error response parameters are available in the API Reference Guide.

1.4 Fetch Payment Methods

You can accept payments through UPI, credit and debit cards, netbanking and wallets, as per the methods enabled on your account.
  • When you use Razorpay Android Standard SDK, you do not have to handle the availability of different payment methods.
  • When creating a Custom checkout form, you must ensure that only the methods activated for your account are displayed to the customer.
To get a list of available payment methods, call getPaymentMethods. This fetches the list of payment methods asynchronously and returns the result in JSON format in the onPaymentMethodsReceived callback.

Sample Code

The following is an API used to fetch all enabled payment methods for a given API Key ID:
Payment Methods API
Java
Check the various payment methods available with Razorpay Android Custom SDK.
Handy TipsIf you are using Subscriptions, you can pass the subscription_id in the options, which fetches subscription-related details along with the payment method. This saves you a network call to get amount for that subscription_id. Know more about Subscriptions.

1.5 Set Up WebView

The bank ACS pages are displayed to the user in a WebView. You need to define a WebView in your layout and pass the reference to our SDK using setWebView, as shown below:
Java

1.6 Submit Payment Data and Handle Success and Error Events

Once you have received the customer’s payment information, it needs to be sent to our API to complete the creation step of the payment flow. You can do this by invoking submit method. Before invoking this method, you have to make your webview visible to the customer. The data that needs to be submitted in the form of a JSONObject is shown below.
Java
Below is a complete list of Checkout form parameters: key mandatory : string API Key ID generated from DashboardAccount & SettingsAPI Keys. amount mandatory : integer The amount to be paid by the customer in currency subunits. For example, if the amount is 100, enter 10000. In the case of three decimal currencies, such as KWD, BHD and OMR, to accept a payment of 295.991, pass the value as 295990. And in the case of zero decimal currencies such as JPY, to accept a payment of 295, pass the value as 295.
Watch Out!As per payment guidelines, you should pass the last decimal number as 0 for three decimal currency payments. For example, if you want to charge a customer 99.991 KD for a transaction, you should pass the value for the amount parameter as 99990 and not 99991.currency mandatory : string The currency in which the payment should be made by the customer. For example, INR. See the list of supported currencies.
Handy TipsRazorpay has added support for zero decimal currencies, such as JPY, and three decimal currencies, such as KWD, BHD, and OMR, allowing businesses to accept international payments in these currencies. Know more about Currency Conversion (May 2024).description optional : string Description of the product shown in the Checkout form. It must start with an alphanumeric character.image optional : string Link to an image (usually your business logo) shown in the Checkout form. Can also be a base64 string, if loading the image from a network is not desirable.order_id mandatory : string Order ID generated via the Orders API.notes optional : object Set of key-value pairs that can be used to store additional information about the payment. It can hold a maximum of 15 key-value pairs, each 256 characters long (maximum).method mandatory : string The payment method used by the customer on Checkout. Possible values:
  • card (default)
  • upi (default)
  • netbanking (default)
  • wallet (default)
  • emi (default)
  • cardless_emi (requires approval)
  • paylater (requires approval)
  • emandate (requires approval)
card mandatory if method=card/emi : object The details of the card that should be entered while making the payment.number : integer Unformatted card number.name : string The name of the cardholder.expiry_month : integer Expiry month for card in MM format.expiry_year : integer Expiry year for card in YY format.cvv : integer CVV printed on the back of the card.
Handy Tips
  • CVV is not required by default for tokenised cards across all networks.
  • CVV is optional for tokenised card payments. Do not pass dummy CVV values.
  • To implement this change, skip passing the cvv parameter entirely, or pass a null or empty value in the CVV field.
  • We recommend removing the CVV field from your checkout UI/UX for tokenised cards.
  • If CVV is still collected for tokenised cards and the customer enters a CVV, pass the entered CVV value to Razorpay. emi_duration : integer Defines the number of months in the EMI plan.
bank_account mandatory if method=emandate : The details of the bank account that should be passed in the request. These details include bank account number, IFSC code and the name of the customer associated with the bank account.account_number : string Bank account number used to initiate the payment.ifsc : string IFSC of the bank used to initiate the payment.name : string Name associated with the bank account used to initiate the payment.bank mandatory if method=netbanking : string Bank code. List of available banks enabled for your account can be fetched via methods.wallet mandatory if method=wallet : string Wallet code for the wallet used for the payment. Possible values:provider mandatory if method=cardless_emi/paylater : string Name of the cardless EMI provider partnered with Razorpay.Available options for Cardless EMI (requires approval):
  • hdfc
  • icic
  • idfb
  • kkbk
  • zestmoney
  • earlysalary
  • walnut369
Available options for Pay Later:
  • lazypay
  • paypal
vpa mandatory if method=upi : string UPI ID used for making the payment on the UPI app.
Deprecation NoticeUPI Collect is deprecated effective 28 February 2026. This tab is applicable only for exempted businesses. If you are not covered by the exemptions, refer to the migration documentation to switch to UPI Intent.callback_url optional : string The URL to which the customer must be redirected upon completion of payment. The URL must accept incoming POST requests. The callback URL will have razorpay_payment_id, razorpay_order_id and razorpay_signature as the request parameters for a successful payment.redirect conditionally mandatory : boolean Determines whether customer should be redirected to the URL mentioned in the callback_url parameter. This is mandatory if callback_url parameter is used. Possible values:
  • true: Customer will be redirected to the callback_url.
  • false: Customer will not be redirected to the callback_url
Handy TipsTo reuse the Razorpay Checkout web integration inside a web view on Android or iOS, pass a callback_url along with other checkout options to process the desired payment.

Use PaymentResultWithDataListener

You have the option to implement PaymentResultListener or PaymentResultWithDataListener to receive callbacks for the payment result.
  • PaymentResultListener provides only payment_id as the payment result.
  • PaymentResultWithDataListener provides additional payment data such as email and contact of the customer, along with the order_id, payment_id, signature and more.
Java

1.7 Store Fields in Your Server

A successful payment returns the following fields to the Checkout form.

Success Callback

  • You need to store these fields in your server.
  • You can confirm the authenticity of these details by verifying the signature in the next step.
Success Callback
razorpay_payment_id : string Unique identifier for the payment returned by Checkout only for successful payments. razorpay_order_id : string Unique identifier for the order returned by Checkout. razorpay_signature : string Signature returned by the Checkout. This is used to verify the payment.

1.8 Verify Payment Signature

This is a mandatory step to confirm the authenticity of the details returned to the Checkout form for successful payments.

To verify the razorpay_signature returned to you by the Checkout form:

  1. Create a signature in your server using the following attributes:
    • order_id: Retrieve the order_id from your server. Do not use the razorpay_order_id returned by Checkout.
    • razorpay_payment_id: Returned by Checkout.
    • key_secret: Available in your server. The key_secret that was generated from the Dashboard.
  2. Use the SHA256 algorithm, the razorpay_payment_id and the order_id to construct a HMAC hex digest as shown below:
    HMAC Hex Digest
  3. If the signature you generate on your server matches the razorpay_signature returned to you by the Checkout form, the payment received is from an authentic source.

Generate Signature on Your Server

Given below is the sample code for payment signature verification:
Java

Post Signature Verification

After you have completed the integration, you can set up webhooks, make test payments, replace the test key with the live key and integrate with other APIs.

1.9 Verify Payment Status

Handy TipsOn the Razorpay Dashboard, ensure that the payment status is captured. Refer to the payment capture settings page to know how to capture payments automatically.

You can track the payment status in three ways:

To verify the payment status from the Razorpay Dashboard:
  1. Log in to the Razorpay Dashboard and navigate to TransactionsPayments.
  2. Check if a Payment Id has been generated and note the status. In case of a successful payment, the status is marked as Captured.
You can use Razorpay webhooks to configure and receive notifications when a specific event occurs. When one of these events is triggered, we send an HTTP POST payload in JSON to the webhook’s configured URL. Know how to set up webhooks.

Example

If you have subscribed to the order.paid webhook event, you will receive a notification every time a customer pays you for an order. Poll Payment APIs to check the payment status.

Integrate Payments Rainy Day Kit

Use Payments Rainy Day kit to overcome payments exceptions such as:

Next Steps

Step 2: Test Integration